/*LINTLIBRARY*/
/*  misc.c

    This code provides convenience callback routines

    Copyright (C) 2002-2003  Richard Gooch

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Richard Gooch may be reached by email at  karma-request@atnf.csiro.au
    The postal address is:
      Richard Gooch, c/o ATNF, P. O. Box 76, Epping, N.S.W., 2121, Australia.
*/

/*  This file contains convenience callback routines.


    Written by      Richard Gooch   28-DEC-2002

    Updated by      Richard Gooch   7-JUN-2003: Created experimental function
  <c_write_2nulls_func>.

    Last updated by Richard Gooch   6-AUG-2003: Created experimental function
  <c_unregister_callback2>.


*/
#include <stdio.h>
#include <karma.h>
#include <karma_c.h>


/*  Private functions  */


/*  Private data  */


/*  Public functions follow  */

/*EXPERIMENTAL_FUNCTION*/
void c_write_null_func (void **pointer)
/*  [SUMMARY] Write NULL to a pointer.
    <pointer> The pointer to write NULL to.
    [RETURNS] Nothing.
*/
{
    *pointer = NULL;
}   /*  End Function c_write_null_func  */

/*EXPERIMENTAL_FUNCTION*/
void c_write_2nulls_func (void *pointer)
/*  [SUMMARY] Write NULL values to a structure containing two pointers.
    <pointer> The pointer to the structure to write to.
    [RETURNS] Nothing.
*/
{
    struct mystruct {void *p1; void *p2;} *ptr = pointer;

    ptr->p1 = NULL;
    ptr->p2 = NULL;
}   /*  End Function c_write_2nulls_func  */

/*EXPERIMENTAL_FUNCTION*/
void c_unregister_callback2 (KCallbackFunc callback)
/*  [SUMMARY] Unregister a callback function.
    <callback> The callback function. If this is NULL, nothing is done.
    [RETURNS] Nothing.
*/
{
    if (!callback) return;
    c_unregister_callback (callback);
}   /*  End Function c_unregister_callback2  */
